package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.MusicPlayerSingleton;
import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Exceptions.DatabaseException;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Persistence;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.layout.VBox;

import java.io.IOException;
import java.util.Objects;

public class MapForgeController {
    @FXML
    private VBox parent;
    SceneLoader sceneLoader = new SceneLoader();
    private final Persistence persistence = Persistence.getInstance();

    @FXML
    private void mapEditorScene() {
        try {
            parent.getScene().setRoot(FXMLLoader.load(Objects.requireNonNull(getClass().getResource("/fxml/Placeholder.fxml"))));
            MusicPlayerSingleton.getInstance().getMediaPlayer().dispose();
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

    @FXML
    private void communityMapScene() {
        switchScene("CommunityMaps");
    }

    @FXML
    private void updateMapScene() throws DatabaseException {
        persistence.updateCoreMaps();
//        TODO: set message label if update was successful or not
    }

    @FXML
    private void backButton() {
        switchScene("MainMenu");
    }

    private void switchScene(String name) {
        parent.getChildren().clear();
        parent.getChildren().add(sceneLoader.loadScene(name));
    }
}
