package de.hdm_stuttgart.battlearena.Controller.Utilities;

import javafx.animation.FadeTransition;
import javafx.scene.control.ToggleButton;
import javafx.scene.control.skin.ToggleButtonSkin;
import javafx.util.Duration;

public class ToggleButtonTransition extends ToggleButtonSkin {
    private final FadeTransition fadeIn;
    private final FadeTransition fadeOut;

    public ToggleButtonTransition(ToggleButton toggleButton) {
        super(toggleButton);

        fadeIn = new FadeTransition(Duration.millis(150));
        fadeIn.setNode(toggleButton);
        fadeIn.setToValue(1);

        fadeOut = new FadeTransition(Duration.millis(150));
        fadeOut.setNode(toggleButton);
        fadeOut.setToValue(0.5);

        toggleButton.setOnMouseEntered(e -> fadeIn.playFromStart());
        toggleButton.setOnMouseExited(e -> {
            if (!toggleButton.isSelected()) {
                fadeOut.playFromStart();
            }
        });

        toggleButton.selectedProperty().addListener((observable, oldValue, newValue) -> {
            if (newValue) {
                fadeIn.playFromStart();
                fadeOut.setToValue(0.5); // Set fadeOut back to the default value
            } else {
                fadeOut.playFromStart();
                toggleButton.setOpacity(0.5);
            }
        });

        // Set the initial opacity based on the initial selected state
        toggleButton.setOpacity(toggleButton.isSelected() ? 1.0 : 0.5);

    }
}





