package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.AccountType;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadStartup3 extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadStartup3.class);

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        Threads threadsInstance = Threads.getInstance();

        try {
            threadsInstance.setThreadStartup3Msg("");
            threadsInstance.setThreadStartup3(ThreadStatus.RUNNING);
            persistenceInst.loadPlayerStatistics();
            if(persistenceInst.getAccount().getAccountType() != AccountType.NONE){
                persistenceInst.verifyPlayerAccount();
            }
            log.info("Startup routine part3 complete!");
            threadsInstance.setThreadStartup3(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            threadsInstance.setThreadStartup3Msg(e.getMessage());
            log.info("Startup routine part3 failed!");
            threadsInstance.setThreadStartup3(ThreadStatus.FAILED);
        }
    }

}
