package de.hdm_stuttgart.battlearena.Model.Entity;

import de.hdm_stuttgart.battlearena.Controller.GameSceneController;
import javafx.geometry.BoundingBox;
import javafx.scene.canvas.GraphicsContext;

public interface IEntity {

   void initializeEntity();

   void loadEntitySprites();

   void updateEntityMovement(GameSceneController gameScene);

   void checkHealTile(IEntity entity, GraphicsContext graphicsContext);

   void attack(IEntity entity, GraphicsContext graphicsContext);

   void updateEntityWalkAnimation();

   void renderEntity(GraphicsContext graphicsContext);

    void healPlayer(int heal);

    BoundingBox getBoxCollider();

   EntityDirection getEntityDirection();

   int getEntitySpeed();

   void gotHit(int damageDone);

   int getMapPosX();

   int getMapPosY();

}