package de.hdm_stuttgart.battlearena.Model.Entity;

import de.hdm_stuttgart.battlearena.Controller.GameSceneController;

import javafx.geometry.BoundingBox;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

class NetworkPlayerTwo implements IEntity{

    private static final Logger log = LogManager.getLogger(NetworkPlayerTwo.class);

    private final BoundingBox boxCollider = new BoundingBox(300, 200, 48, 48);

    private EntityDirection entityDirection = EntityDirection.DOWN;

    private int entitySpeed = 3;

    private int health = 10;

    @Override
    public void initializeEntity() {

    }

    @Override
    public void loadEntitySprites() {

    }

    @Override
    public void updateEntityMovement(GameSceneController gameScene) {

    }

    @Override
    public void checkHealTile(IEntity entity, GraphicsContext graphicsContext) {

    }

    @Override
    public void attack(IEntity entity, GraphicsContext graphicsContext) {

    }

    @Override
    public void updateEntityWalkAnimation() {

    }

    @Override
    public void renderEntity(GraphicsContext graphicsContext) {
        graphicsContext.setFill(Color.BLACK);
        graphicsContext.fillRect(300, 200, 48, 48);
    }

    @Override
    public void healPlayer(int heal) {
        log.info("Network player health: " + health);
        health -= heal;
    }

    @Override
    public BoundingBox getBoxCollider() {
        return boxCollider;
    }

    @Override
    public EntityDirection getEntityDirection() {
        return entityDirection;
    }

    @Override
    public int getEntitySpeed() {
        return 3;
    }

    @Override
    public void gotHit(int damageDone) {
        log.debug("Network player health: " + health);
        health -= damageDone;
    }

    @Override
    public int getMapPosX() {
        return 0;
    }

    @Override
    public int getMapPosY() {
        return 0;
    }

}