package de.hdm_stuttgart.battlearena.Model.Sound;


import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

import javafx.scene.media.AudioClip;


import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Random;
import java.util.concurrent.Executors;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class SoundManager implements ISoundManager {
    private static final Logger log = LogManager.getLogger(SoundManager.class);


    private final ThreadPoolExecutor executor = (ThreadPoolExecutor) Executors.newFixedThreadPool(5);
    private final List<SFX> soundEffectsRunning = new ArrayList<>();
    private MediaPlayer mediaPlayer;

    private final boolean stopLoop = false;
    private List<Path> walkingSFXPaths;

    //Todo Make music play
    public void playMusic(MusicType musicType) throws IOException {
        Path pathTypeOfMusic = Paths.get(musicType.getPath());
        List<Path> musicPaths = getFilePathsFromResources(pathTypeOfMusic);
        Random random = new Random();
        int min = 0;
        int max = musicPaths.size() - 1;
        int randomIndex = random.nextInt(max - min + 1 ) + min;
        String randomMusic = musicPaths.get(randomIndex).toString();
        String normalizedPath = Paths.get(randomMusic).toString().replace('\\', '/');
        String resource = normalizedPath.substring(18);
        log.info(resource);
        Thread thread = new Thread(() -> {
            Media media = new Media(getClass().getResource(resource).toExternalForm());
            mediaPlayer = new MediaPlayer(media);
            mediaPlayer.setCycleCount(MediaPlayer.INDEFINITE);
            mediaPlayer.play();
            log.info("Music is playing");

        });
        thread.setDaemon(true);
        thread.start();
    }

    public void stopMusic(){
        if (mediaPlayer != null) {
            mediaPlayer.dispose(); // Dispose of the MediaPlayer instance
        }
    }

    @Override
    public void playSoundEffect() throws InterruptedException, MalformedURLException {

    }



    public List<Path> getFilePathsFromResources(Path folderPath) throws IOException {
        List<Path> result;
        try (Stream<Path> walk = Files.walk(folderPath)) {
            result = walk.filter(Files::isRegularFile)
                    .collect(Collectors.toList());
        }
        return result;
    }

}
